package com.spring.mvc.demo;

import java.io.IOException;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.spring.mvc.demo.exception.MyException;

@Controller
public class ExceptionCtrl {

	@RequestMapping(value= "/exception/{type}", method= RequestMethod.GET)
	public String exception(@PathVariable(name="type") String exception) throws IOException {

		if (exception.equalsIgnoreCase("error")) {			
			throw new MyException("A1001", "This is a custom exception message.");
		} else if (exception.equalsIgnoreCase("io-error")) {			
			throw new IOException();
		} else {
			return "success";
		}
	}

	@ExceptionHandler(MyException.class)
	public ModelAndView handleMyException(MyException mex) {

		ModelAndView model = new ModelAndView();
		model.addObject("errCode", mex.getErrCode());
		model.addObject("errMsg", mex.getErrMsg());
		model.setViewName("error/generic_error");
		return model;
	}

	@ExceptionHandler(Exception.class)
	public ModelAndView handleException(Exception ex) {

		ModelAndView model = new ModelAndView();
		model.addObject("errMsg", "This is a 'Exception.class' message.");
		model.setViewName("error/generic_error");
		return model;

	}
}